unit Unit4;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, Controls,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl,
  IWCompEdit, IWCompButton, IWCompLabel, IWCompListbox, IWHTML5Chart, IWHTML5Base,
  IWCompCheckbox, Forms, IWVCLBaseContainer, IWContainer, IWHTMLContainer,
  IWHTML40Container, IWRegion;

type
  TIWForm4 = class(TIWAppForm)
    TIWHTML5Chart1: TTIWHTML5Chart;
    IWRegion1: TIWRegion;
    IWLabel14: TIWLabel;
    IWLabel15: TIWLabel;
    IWLabel8: TIWLabel;
    IWComboBoxType: TIWComboBox;
    IWLabel5: TIWLabel;
    IWRegion2: TIWRegion;
    IWLabel16: TIWLabel;
    IWCheckBox3D: TIWCheckBox;
    IWCheckBoxOpacity: TIWCheckBox;
    IWComboBoxGradient: TIWComboBox;
    IWLabel12: TIWLabel;
    IWComboBoxRange: TIWComboBox;
    IWLabel11: TIWLabel;
    IWRegion3: TIWRegion;
    IWLabel17: TIWLabel;
    IWLabel9: TIWLabel;
    IWComboBoxMarkers: TIWComboBox;
    IWLabel6: TIWLabel;
    IWLabel13: TIWLabel;
    IWComboBoxAlign: TIWComboBox;
    IWRegion4: TIWRegion;
    IWLabel18: TIWLabel;
    IWLabelEvents: TIWLabel;
    IWRegion5: TIWRegion;
    IWLabel10: TIWLabel;
    IWCheckBoxAnno: TIWCheckBox;
    IWLabel19: TIWLabel;
    IWComboBoxLegendPos: TIWComboBox;
    IWComboBoxOrientation: TIWComboBox;
    IWCheckBoxLabels: TIWCheckBox;
    IWLabel20: TIWLabel;
    IWLabel21: TIWLabel;
    IWLabel22: TIWLabel;
    IWLabel23: TIWLabel;
    IWComboBoxSerie: TIWComboBox;
    IWComboBoxItems: TIWComboBox;
    IWLabel24: TIWLabel;
    IWCheckBoxBands: TIWCheckBox;
    IWCheckBoxAnim: TIWCheckBox;
    IWCheckBoxLayer: TIWCheckBox;
    IWRegion6: TIWRegion;
    IWLabel2: TIWLabel;
    IWLabel25: TIWLabel;
    IWLabel3: TIWLabel;
    IWCheckBoxRotate: TIWCheckBox;
    procedure IWAppFormCreate(Sender: TObject);
    procedure IWAppFormRender(Sender: TObject);
    procedure TIWHTML5Chart1AsyncClick(Sender: TObject;
      EventParams: TStringList);
    procedure TIWHTML5Chart1AsyncAnnotationClick(Sender: TObject;
      EventParams: TStringList; AnnotationIndex: Integer);
    procedure TIWHTML5Chart1AsyncItemLayerClick(Sender: TObject;
      EventParams: TStringList; ItemLayerIndex: Integer);
    procedure TIWHTML5Chart1AsyncLegendClick(Sender: TObject;
      EventParams: TStringList; SerieIndex: Integer);
    procedure IWComboBoxAsyncChange(Sender: TObject;
      EventParams: TStringList);
    procedure IWCheckBoxAsyncClick(Sender: TObject;
      EventParams: TStringList);
    procedure TIWHTML5Chart1AsyncSerieClick(Sender: TObject;
      EventParams: TStringList; SerieIndex, PointIndex: Integer);
  public
    procedure BuildChart(Async: boolean);
  end;

var
  Values: array[0..4, 0..49] of double;
  XValues: array[0..4, 0..49] of double;
  PresetColors: array[0..4] of TIWColor = (clWebOrange, clWebSeaGreen, clwebRoyalBlue, clWebYellow, clWebTurquoise);
  PresetGrColors: array[0..4] of TIWColor = (clWebDARKORANGE, clWebDarkGreen, clwebDarkBlue, clWebOrange, clWebTeal);

implementation

{$R *.dfm}

procedure TIWForm4.BuildChart(Async: boolean);
var
  I: Integer;
  J: Integer;
begin

  TIWHTML5Chart1.Series.Clear;

  TIWHTML5Chart1.YAxis.DecimalPrecision := 0;
  TIWHTML5Chart1.XAxis.DecimalPrecision := 0;

  TIWHTML5Chart1.Legend.Caption := 'My Legend';

  if IWComboBoxLegendPos.ItemIndex = 0 then
    TIWHTML5Chart1.Legend.Position := lpNone
  else if IWComboBoxLegendPos.ItemIndex = 1 then
    TIWHTML5Chart1.Legend.Position := lpCenter
  else if IWComboBoxLegendPos.ItemIndex = 2 then
    TIWHTML5Chart1.Legend.Position := lpLeft
  else if IWComboBoxLegendPos.ItemIndex = 3 then
    TIWHTML5Chart1.Legend.Position := lpRight;

  if IWComboBoxOrientation.ItemIndex = 0 then
    TIWHTML5Chart1.Legend.Orientation := oHorizontal
  else
    TIWHTML5Chart1.Legend.Orientation := oVertical;

  TIWHTML5Chart1.Legend.BGColor := clWebWhite;
  TIWHTML5Chart1.Legend.BGColorTo := $F0E5E4;

  if IWCheckBoxOpacity.Checked then
    TIWHTML5Chart1.Legend.Opacity := 200
  else
    TIWHTML5Chart1.Legend.Opacity := 255;

  TIWHTML5Chart1.Hint.BGColor := clWebWhite;
  TIWHTML5Chart1.Hint.BGColorTo := $F0E5E4;

  TIWHTML5Chart1.Annotations.Clear;

  TIWHTML5Chart1.ItemLayer.Clear;

  if IWCheckBoxLayer.Checked then
  begin
    with TIWHTML5Chart1.ItemLayer.Add do
    begin
      Top := 150;
      Left := 200;
      Caption := 'Item in front';
      BGColor := clWebGold;
      BGColorTo := clWebOrange;
      BGGradientDirection := gdVertical;
      Shape := sCircle;
      Position := pFront;
    end;

    with TIWHTML5Chart1.ItemLayer.Add do
    begin
      Top := 325;
      Left := 400;
      Caption := 'Item in the back';
      BGColor := clWebAliceBlue;
      BGColorTo := clWebDodgerBlue;
      BorderColor := clWebDarkBlue;
      Font.Color := clWebWhite;
      BGGradientDirection := gdVertical;
      Shape := sRectangle;
      Height := 25;
      Width := 110;
      Position := pBack;
    end;
  end;

  for J := 0 to StrToInt(IWComboBoxSerie.Items[IWComboBoxSerie.ItemIndex]) - 1 do
  begin

    with TIWHTML5Chart1.Series.Add do
    begin

      if IWComboBoxType.ItemIndex = 0 then
      begin
        SerieType := stArea;
        LineWidth := 1;
      end
      else if IWComboBoxType.ItemIndex = 1 then
      begin
        SerieType := stBar;
        LineWidth := 1;
      end
      else if IWComboBoxType.ItemIndex = 3 then
      begin
        SerieType := stStackedArea;
        LineWidth := 1;
      end
      else if IWComboBoxType.ItemIndex = 4 then
      begin
        SerieType := stStackedBar;
        LineWidth := 1;
      end
      else if IWComboBoxType.ItemIndex = 5 then
      begin
        SerieType := stXY;
        LineWidth := 1;
      end
      else
      begin
        SerieType := stLine;
        LineWidth := 2;
      end;

      MarkerType := mtNone;
      MarkerSize := 10;
      Name := 'This is Serie ' + IntToStr(J);

      if IWCheckBoxRotate.Checked then
        XAxis.Rotate := true;

      if IWComboBoxMarkers.ItemIndex = 1 then
        MarkerType := mtCircle
      else if IWComboBoxMarkers.ItemIndex = 2 then
        MarkerType := mtSquare
      else if IWComboBoxMarkers.ItemIndex = 3 then
        MarkerType := mtTriangle
      else if IWComboBoxMarkers.ItemIndex = 4 then
      begin
        MarkerType := mtImage;
        MarkerImageURL := '/files/marker.png';
        MarkerSize := 24;
      end;

      TIWHTML5Chart1.Series[J].YAxis.Delta := 20;
      TIWHTML5Chart1.Series[J].XAxis.Delta := 20;

      if J > 0 then
      begin
        TIWHTML5Chart1.Series[J].XAxis.Visible := false;
        TIWHTML5Chart1.Series[J].YAxis.Visible := false;
      end;

      //LabelType := ltSum;
      LineColor := PresetGrColors[J];
      BGColor := PresetColors[J];
      MarkerColor := PresetColors[J];

      if IWComboBoxGradient.ItemIndex > 0 then
      begin
        BGColorTo := PresetGrColors[J];
        BGGradientDirection := IWHTML5Base.TTIWGradientDirection
          (IWComboBoxGradient.ItemIndex - 1);

        SelectedBGColor := clWebOrange;
        SelectedBGColorTo := clWebRed;
      end
      else
        BGColorTo := BGColor;

      if IWComboBoxType.ItemIndex = 2 then
      begin
        BGColor := LineColor;
        BGColorTo := LineColor;
      end;

      if IWCheckBoxOpacity.Checked then
        Opacity := 200
      else
        Opacity := 255;

      ShowLabels := IWCheckBoxLabels.Checked;
      Show3D := IWCheckBox3D.Checked;

      if IWComboBoxAlign.ItemIndex = 0 then
        ItemAlignment := iaCenter
      else if IWComboBoxAlign.ItemIndex = 1 then
        ItemAlignment := iaLeft;

      if IWComboBoxRange.ItemIndex = 0 then
      begin
        RangeFrom := 0;
        RangeTo := 100;

        XRangeFrom := 0;
        XRangeTo := 100;
      end
      else if IWComboBoxRange.ItemIndex = 1 then
      begin
        RangeFrom := -100;
        RangeTo := 0;

        XRangeFrom := -100;
        XRangeTo := 0;
      end
      else if IWComboBoxRange.ItemIndex = 2 then
      begin
        RangeFrom := -100;
        RangeTo := 100;

        XRangeFrom := -100;
        XRangeTo := 100;
      end;

      for I := 0 to StrToInt(IWComboBoxItems.Items[IWComboBoxItems.ItemIndex]) - 1 do
      begin
        with Items.Add do
        begin

          Value := Values[J, I];
          XValue := XValues[J, I];

          if IWComboBoxRange.ItemIndex > 0 then
          begin
            if (Random(2) = 0) or (IWComboBoxRange.ItemIndex = 1) then
              Value := -Value;
            if (Random(2) = 0) or (IWComboBoxRange.ItemIndex = 1) then
              XValue := -XValue;
          end;

          XAxis := IntToStr(I + 1);

          if IWCheckBoxAnno.Checked then
          begin
            with TIWHTML5Chart1.Annotations.Add do
            begin
              SerieIndex := J;
              PointIndex := I;
              Caption := 'Point ' + IntToStr(SerieIndex)
                + '.' + IntToStr(PointIndex) + ' = ' + FloatToStr(TIWHTML5Chart1.Series[SerieIndex].Items[PointIndex].Value);

              if IWComboBoxGradient.ItemIndex > 0 then
              begin
                BGColor := clWebPINK;
                BGColorTo := clWebDARKRED;
                BGGradientDirection := IWHTML5Base.TTIWGradientDirection
                  (IWComboBoxGradient.ItemIndex - 1);
                Font.Color := clWebWhite;
              end
              else
              begin
                BGColor := clWebWHITESMOKE;
                BGColorTo := BGColor;
                Font.Color := clWebBlack;
              end;
            end;
          end;
        end;
      end;
    end;
  end;

  TIWHTML5Chart1.Bands.Enabled := IWCheckBoxBands.Checked;
  TIWHTML5Chart1.ShowAnimation := IWCheckBoxAnim.Checked;

  if Async then
    TIWHTML5Chart1.AsyncUpdateAllValues;
end;

procedure TIWForm4.IWAppFormCreate(Sender: TObject);
var
  I: integer;
  J: Integer;
begin

  //create random series values
  for J := 0 to Length(Values) - 1 do
  begin
    for I := 0 to Length(Values[J]) - 1 do
      Values[J, I] := Random(101);
  end;

  for J := 0 to Length(XValues) - 1 do
  begin
    for I := 0 to Length(XValues[J]) - 1 do
      XValues[J, I] := Random(101);
  end;

  TIWHTML5Chart1.BGColor := clWebWhite;
  if IWComboBoxGradient.ItemIndex > 0 then
  begin
    TIWHTML5Chart1.BGColorTo := clWebLIGHTSTEELBLUE;
    TIWHTML5Chart1.BGGradientDirection := IWHTML5Base.TTIWGradientDirection
      (IWComboBoxGradient.ItemIndex - 1);
  end
  else
    TIWHTML5Chart1.BGColorTo := TIWHTML5Chart1.BGColor;
  TIWHTML5Chart1.BorderColor := clWebSilver;

  BuildChart(False);
end;

procedure TIWForm4.IWAppFormRender(Sender: TObject);
begin
  PageContext.DocType := '<!DOCTYPE html>';
  PageContext.AddStyle('BODY { font-family: Arial; }');
end;

procedure TIWForm4.IWCheckBoxAsyncClick(Sender: TObject;
  EventParams: TStringList);
begin
  BuildChart(True);
end;

procedure TIWForm4.IWComboBoxAsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  BuildChart(True);
end;

procedure TIWForm4.TIWHTML5Chart1AsyncAnnotationClick(Sender: TObject;
  EventParams: TStringList; AnnotationIndex: Integer);
begin
  IWLabelEvents.Text := 'Annotation click ' + IntToStr(AnnotationIndex);
end;

procedure TIWForm4.TIWHTML5Chart1AsyncClick(Sender: TObject;
  EventParams: TStringList);
begin
  IWLabelEvents.Text := 'Chart click';

  TIWHTML5Chart1.AsyncUpdateAllValues;
end;

procedure TIWForm4.TIWHTML5Chart1AsyncItemLayerClick(Sender: TObject;
  EventParams: TStringList; ItemLayerIndex: Integer);
begin
  IWLabelEvents.Text := 'Item Layer click ' + IntToStr(ItemLayerIndex);
end;

procedure TIWForm4.TIWHTML5Chart1AsyncLegendClick(Sender: TObject;
  EventParams: TStringList; SerieIndex: Integer);
begin
  IWLabelEvents.Text := 'Legend click ' + IntToStr(SerieIndex);
end;

procedure TIWForm4.TIWHTML5Chart1AsyncSerieClick(Sender: TObject;
  EventParams: TStringList; SerieIndex, PointIndex: Integer);
begin
  IWLabelEvents.Text := 'Serie click: Serie = ' + IntToStr(SerieIndex)
    + ' Point = ' + IntToStr(PointIndex);

  TIWHTML5Chart1.AsyncUpdateAllValues;
end;

initialization

TIWForm4.SetAsMainForm;

end.
