unit Unit4;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, IWControl,
  IWHTML5Gauge, Controls, IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl,
  IWCompLabel, IWCompButton, IWCompEdit, IWBaseComponent, IWBaseHTMLComponent,
  IWBaseHTML40Component, IWCompListbox, IWCompCheckbox, Forms,
  IWVCLBaseContainer, IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion
  {IW121}
  {Uncomment the line below when using IntraWeb 12.1 or higher}
  , IWCompExtCtrls
  {Pre IW121}
  {Uncomment the line below when using IntraWeb 12.0 or lower}
  //, IWExtCtrls
  ;

type
  TIWForm4 = class(TIWAppForm)
    IWLabel1: TIWLabel;
    TIWHTML5Gauge1: TTIWHTML5Gauge;
    TIWHTML5Gauge3: TTIWHTML5Gauge;
    IWLabel2: TIWLabel;
    IWTimer1: TIWTimer;
    IWLabel3: TIWLabel;
    IWLabel11: TIWLabel;
    TIWHTML5Gauge2: TTIWHTML5Gauge;
    IWLabel9: TIWLabel;
    IWLabel6: TIWLabel;
    IWRegion1: TIWRegion;
    IWRegion2: TIWRegion;
    IWLabel10: TIWLabel;
    IWLabel7: TIWLabel;
    IWLabel5: TIWLabel;
    IWCheckBox1: TIWCheckBox;
    IWCheckBox2: TIWCheckBox;
    IWCheckBox3: TIWCheckBox;
    cbSetPoints: TIWComboBox;
    cbRange: TIWComboBox;
    cbValue: TIWComboBox;
    IWRegion3: TIWRegion;
    IWRegion4: TIWRegion;
    IWLabel17: TIWLabel;
    IWLabel4: TIWLabel;
    IWLabel8: TIWLabel;
    cbDisplay: TIWComboBox;
    IWEdit2: TIWEdit;
    IWRegion5: TIWRegion;
    IWRegion6: TIWRegion;
    IWLabel16: TIWLabel;
    IWLabel14: TIWLabel;
    cbNeedle: TIWComboBox;
    procedure IWAppFormRender(Sender: TObject);
    procedure IWAppFormCreate(Sender: TObject);
    procedure IWTimer1AsyncTimer(Sender: TObject; EventParams: TStringList);
    procedure IWCheckBox1AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure cbSetPointsAsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWCheckBox3AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWCheckBox2AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure cbNeedleAsyncChange(Sender: TObject; EventParams: TStringList);
    procedure cbDisplayAsyncChange(Sender: TObject; EventParams: TStringList);
    procedure cbRangeAsyncChange(Sender: TObject; EventParams: TStringList);
    procedure cbValueAsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWEdit2AsyncKeyUp(Sender: TObject; EventParams: TStringList);
    procedure TIWHTML5Gauge1AsyncGaugeClick(Sender: TObject;
      EventParams: TStringList; Value: Double);
    procedure TIWHTML5Gauge2AsyncGaugeClick(Sender: TObject;
      EventParams: TStringList; Value: Double);
    procedure TIWHTML5Gauge3AsyncGaugeClick(Sender: TObject;
      EventParams: TStringList; Value: Double);
  public
    procedure PresetValueCombo;
    procedure AddSection(start, stop: Double; color: TIWColor);
    procedure UpdateSetPoint(Index: integer; Value: double);
    function GetRandomValue: string;
  end;

implementation

{$R *.dfm}

procedure TIWForm4.PresetValueCombo;
var
  I: integer;
begin
  cbValue.Items.Clear;

  for I := 0 to 10 - 1 do
  begin
    cbValue.Items.Add(GetRandomValue);
  end;
end;

procedure TIWForm4.AddSection(start: Double; stop: Double; color: TIWColor);
var
  MySection: THTML5GaugeSection;
begin
  MySection := TIWHTML5Gauge1.Sections.Add;
  MySection.StartValue := start;
  MySection.EndValue := stop;
  MySection.BGColor := color;
  MySection.Visible := IWCheckBox2.Checked;

  MySection := TIWHTML5Gauge2.Sections.Add;
  MySection.StartValue := start;
  MySection.EndValue := stop;
  MySection.BGColor := color;
  MySection.Visible := IWCheckBox2.Checked;

  MySection := TIWHTML5Gauge3.Sections.Add;
  MySection.StartValue := start;
  MySection.EndValue := stop;
  MySection.BGColor := color;
  MySection.Visible := IWCheckBox2.Checked;
end;

procedure TIWForm4.UpdateSetPoint(Index: integer; Value: double);
begin
  if Index < TIWHTML5Gauge1.SetPoints.Count then
    TIWHTML5Gauge1.SetPoints[Index].Value := Value;

  if Index < TIWHTML5Gauge2.SetPoints.Count then
    TIWHTML5Gauge2.SetPoints[Index].Value := Value;

  if Index < TIWHTML5Gauge3.SetPoints.Count then
    TIWHTML5Gauge3.SetPoints[Index].Value := Value;
end;

function TIWForm4.GetRandomValue: string;
var
  maxvalue: double;
begin
    if (TIWHTML5Gauge1.MaximumValue > 1) and (TIWHTML5Gauge1.MinimumValue = 0) then
      result := IntToStr(Random(Trunc(TIWHTML5Gauge1.MaximumValue + 1)))
    else if (TIWHTML5Gauge1.MaximumValue = 0) and (TIWHTML5Gauge1.MinimumValue < 0) then
      result := IntToStr(Random(Trunc(TIWHTML5Gauge1.MinimumValue - 1) * -1) * -1)
    else if (TIWHTML5Gauge1.MaximumValue > 1) and (TIWHTML5Gauge1.MinimumValue < 0) then
    begin
      maxvalue := TIWHTML5Gauge1.MinimumValue * -1;
      if maxvalue < TIWHTML5Gauge1.MaximumValue then
        maxvalue := TIWHTML5Gauge1.MaximumValue;

      if Random(2) = 1 then
        result := IntToStr(Random(Trunc(maxvalue + 1)))
      else
        result := IntToStr(Random(Trunc(maxvalue + 1)) * -1)

    end
    else if (TIWHTML5Gauge1.MaximumValue = 1) and (TIWHTML5Gauge1.MinimumValue = 0) then
    begin
      maxvalue := Random(Trunc((TIWHTML5Gauge1.MaximumValue * 10) + 1));
      result := FloatToStr(maxvalue / 10);
    end;
end;

procedure TIWForm4.cbDisplayAsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  if cbDisplay.ItemIndex = 0 then
  begin
    with TIWHTML5Gauge1 do
    begin
      StartAngle := 0;
      EndAngle := 360;
      Arc.StartAngle := 135;
      Arc.EndAngle := 405;
      DivisionCount := 10;
      ShowDialText := true;
      ShowValue := true;
    end;
  end
  else if cbDisplay.ItemIndex = 1 then
  begin
    with TIWHTML5Gauge1 do
    begin
      StartAngle := 120;
      EndAngle := 420;
      Arc.StartAngle := 135;
      Arc.EndAngle := 405;
      DivisionCount := 10;
      ShowDialText := true;
      ShowValue := true;
    end;
  end
  else if cbDisplay.ItemIndex = 2 then
  begin
    with TIWHTML5Gauge1 do
    begin
      StartAngle := 180;
      EndAngle := 360;
      Arc.StartAngle := 190;
      Arc.EndAngle := 350;
      DivisionCount := 5;
      ShowDialText := false;
      ShowValue := false;
    end;
  end else if cbDisplay.ItemIndex = 3 then
  begin
    with TIWHTML5Gauge1 do
    begin
      StartAngle := 90;
      EndAngle := 360;
      Arc.StartAngle := 100;
      Arc.EndAngle := 350;
      DivisionCount := 10;
      ShowDialText := false;
      ShowValue := false;
    end;
  end;

  TIWHTML5Gauge1.AsyncUpdateAllValues;
end;

procedure TIWForm4.cbNeedleAsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  TIWHTML5Gauge2.Needle.Shape := TTIWNeedleShape(cbNeedle.ItemIndex);
  TIWHTML5Gauge2.AsyncUpdateAllValues;

  TIWHTML5Gauge3.Needle.Shape := TTIWNeedleShape(cbNeedle.ItemIndex);
  TIWHTML5Gauge3.AsyncUpdateAllValues;
end;

procedure TIWForm4.cbRangeAsyncChange(Sender: TObject;
  EventParams: TStringList);
begin

  TIWHTML5Gauge1.Sections.Clear;
  TIWHTML5Gauge2.Sections.Clear;
  TIWHTML5Gauge3.Sections.Clear;

  if cbRange.ItemIndex = 0 then
  begin
    TIWHTML5Gauge1.ValueFormat := '000';
    TIWHTML5Gauge1.MinimumValue := 0;
    TIWHTML5Gauge1.MaximumValue := 100;
    TIWHTML5Gauge1.DecimalPrecision := 0;

    TIWHTML5Gauge2.MinimumValue := 0;
    TIWHTML5Gauge2.MaximumValue := 100;
    TIWHTML5Gauge2.DecimalPrecision := 0;

    TIWHTML5Gauge3.MinimumValue := 0;
    TIWHTML5Gauge3.MaximumValue := 100;
    TIWHTML5Gauge3.DecimalPrecision := 0;

    AddSection(0, 60, clWebLIGHTGREEN);
    AddSection(60, 80, clwebYellow);
    AddSection(80, 100, clwebRed);

    UpdateSetPoint(0, 25);
    UpdateSetPoint(1, 75);
  end
  else if cbRange.ItemIndex = 1 then
  begin
    TIWHTML5Gauge1.ValueFormat := '000';
    TIWHTML5Gauge1.MinimumValue := -100;
    TIWHTML5Gauge1.MaximumValue := 0;
    TIWHTML5Gauge1.DecimalPrecision := 0;

    TIWHTML5Gauge2.MinimumValue := -100;
    TIWHTML5Gauge2.MaximumValue := 0;
    TIWHTML5Gauge2.DecimalPrecision := 0;

    TIWHTML5Gauge3.MinimumValue := -100;
    TIWHTML5Gauge3.MaximumValue := 0;
    TIWHTML5Gauge3.DecimalPrecision := 0;

    AddSection(-100, -40, clWebLIGHTGREEN);
    AddSection(-40, -20, clwebYellow);
    AddSection(-20, 0, clwebRed);

    UpdateSetPoint(0, -75);
    UpdateSetPoint(1, -25);
  end
  else if cbRange.ItemIndex = 2 then
  begin
    TIWHTML5Gauge1.ValueFormat := '000';
    TIWHTML5Gauge1.MinimumValue := -100;
    TIWHTML5Gauge1.MaximumValue := 100;
    TIWHTML5Gauge1.DecimalPrecision := 0;

    TIWHTML5Gauge2.MinimumValue := -100;
    TIWHTML5Gauge2.MaximumValue := 100;
    TIWHTML5Gauge2.DecimalPrecision := 0;

    TIWHTML5Gauge3.MinimumValue := -100;
    TIWHTML5Gauge3.MaximumValue := 100;
    TIWHTML5Gauge3.DecimalPrecision := 0;

    AddSection(-100, 20, clWebLIGHTGREEN);
    AddSection(20, 60, clwebYellow);
    AddSection(60, 100, clwebRed);

    UpdateSetPoint(0, -50);
    UpdateSetPoint(1, +50);
  end
  else if cbRange.ItemIndex = 3 then
  begin
    TIWHTML5Gauge1.ValueFormat := '0.0';
    TIWHTML5Gauge1.MinimumValue := 0;
    TIWHTML5Gauge1.MaximumValue := 1;
    TIWHTML5Gauge1.DecimalPrecision := 1;

    TIWHTML5Gauge2.MinimumValue := 0;
    TIWHTML5Gauge2.MaximumValue := 1;
    TIWHTML5Gauge2.DecimalPrecision := 1;

    TIWHTML5Gauge3.MinimumValue := 0;
    TIWHTML5Gauge3.MaximumValue := 1;
    TIWHTML5Gauge3.DecimalPrecision := 1;

    AddSection(0, 0.6, clWebLIGHTGREEN);
    AddSection(0.6, 0.8, clwebYellow);
    AddSection(0.8, 1, clwebRed);

    UpdateSetPoint(0, 0.25);
    UpdateSetPoint(1, 0.75);
  end;

  TIWHTML5Gauge1.AsyncUpdateAllValues;
  TIWHTML5Gauge2.AsyncUpdateAllValues;
  TIWHTML5Gauge3.AsyncUpdateAllValues;

  PresetValueCombo;
end;

procedure TIWForm4.cbSetPointsAsyncChange(Sender: TObject;
  EventParams: TStringList);
var
  I: integer;
begin

  for I := 0 to TIWHTML5Gauge1.SetPoints.Count - 1 do
  begin
      TIWHTML5Gauge1.SetPoints[I].Shape := TTIWPointShape(cbSetPoints.ItemIndex);
  end;

  TIWHTML5Gauge1.AsyncUpdateAllValues;

  for I := 0 to TIWHTML5Gauge2.SetPoints.Count - 1 do
  begin
      TIWHTML5Gauge2.SetPoints[I].Shape := TTIWPointShape(cbSetPoints.ItemIndex);
  end;

  TIWHTML5Gauge2.AsyncUpdateAllValues;

  for I := 0 to TIWHTML5Gauge3.SetPoints.Count - 1 do
  begin
      TIWHTML5Gauge3.SetPoints[I].Shape := TTIWPointShape(cbSetPoints.ItemIndex);
  end;

  TIWHTML5Gauge3.AsyncUpdateAllValues;
end;

procedure TIWForm4.cbValueAsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  TIWHTML5Gauge1.Value := StrToFloat(cbValue.Items[cbValue.ItemIndex]);
  TIWHTML5Gauge1.AsyncUpdateAllValues;

  TIWHTML5Gauge2.Value := TIWHTML5Gauge1.Value;
  TIWHTML5Gauge2.AsyncUpdateAllValues;

  TIWHTML5Gauge3.Value := TIWHTML5Gauge1.Value;
  TIWHTML5Gauge3.AsyncUpdateAllValues;
end;

procedure TIWForm4.IWAppFormCreate(Sender: TObject);
var
  MySetPoint: THTML5GaugeSetPoint;
begin
  //Gauge Initialisation

  //Values
  TIWHTML5Gauge1.ValueFormat := '000';
  PresetValueCombo;

  //SetPoints
  MySetPoint := TIWHTML5Gauge1.SetPoints.Add;
  MySetPoint.Value := 25;

  MySetPoint := TIWHTML5Gauge2.SetPoints.Add;
  MySetPoint.Value := 25;

  MySetPoint := TIWHTML5Gauge3.SetPoints.Add;
  MySetPoint.Value := 25;

  MySetPoint := TIWHTML5Gauge1.SetPoints.Add;
  MySetPoint.Value := 75;

  MySetPoint := TIWHTML5Gauge2.SetPoints.Add;
  MySetPoint.Value := 75;

  MySetPoint := TIWHTML5Gauge3.SetPoints.Add;
  MySetPoint.Value := 75;

  //Sections
  TIWHTML5Gauge1.Arc.BGColor := clWebTransparent;
  TIWHTML5Gauge2.Arc.BGColor := clWebTransparent;
  TIWHTML5Gauge3.Arc.BGColor := clWebTransparent;

  TIWHTML5Gauge1.Sections.Clear;
  TIWHTML5Gauge2.Sections.Clear;
  TIWHTML5Gauge3.Sections.Clear;
  AddSection(0, 60, clWebLIGHTGREEN);
  AddSection(60, 80, clwebYellow);
  AddSection(80, 100, clwebRed);

  //Needle Color
  TIWHTML5Gauge2.Needle.BGColor := clWebOrange;
  TIWHTML5Gauge3.Needle.BGColor := clWebOrange;

  //Needle Image
  TIWHTML5Gauge2.Needle.ImageURL := '/files/star_horiz.png';
  TIWHTML5Gauge3.Needle.ImageURL := '/files/star_vert.png';

end;

procedure TIWForm4.IWAppFormRender(Sender: TObject);
begin
  //IE
  PageContext.DocType := '<!DOCTYPE html>';
end;

procedure TIWForm4.IWCheckBox1AsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  IWTimer1.Enabled := IWCheckBox1.Checked;
end;

procedure TIWForm4.IWCheckBox2AsyncChange(Sender: TObject;
  EventParams: TStringList);
var
  I: integer;
begin
  for I := 0 to TIWHTML5Gauge1.Sections.Count - 1 do
  begin
      TIWHTML5Gauge1.Sections[I].Visible := IWCheckBox2.Checked;
  end;

  TIWHTML5Gauge1.AsyncUpdateAllValues;

  for I := 0 to TIWHTML5Gauge2.Sections.Count - 1 do
  begin
      TIWHTML5Gauge2.Sections[I].Visible := IWCheckBox2.Checked;
  end;

  TIWHTML5Gauge2.AsyncUpdateAllValues;

  for I := 0 to TIWHTML5Gauge3.Sections.Count - 1 do
  begin
      TIWHTML5Gauge3.Sections[I].Visible := IWCheckBox2.Checked;
  end;

  TIWHTML5Gauge3.AsyncUpdateAllValues;
end;

procedure TIWForm4.IWCheckBox3AsyncChange(Sender: TObject;
  EventParams: TStringList);
var
  I: integer;
begin
  for I := 0 to TIWHTML5Gauge1.SetPoints.Count - 1 do
  begin
      TIWHTML5Gauge1.SetPoints[I].Visible := IWCheckBox3.Checked;
  end;

  TIWHTML5Gauge1.AsyncUpdateAllValues;

  for I := 0 to TIWHTML5Gauge2.SetPoints.Count - 1 do
  begin
      TIWHTML5Gauge2.SetPoints[I].Visible := IWCheckBox3.Checked;
  end;

  TIWHTML5Gauge2.AsyncUpdateAllValues;

  for I := 0 to TIWHTML5Gauge3.SetPoints.Count - 1 do
  begin
      TIWHTML5Gauge3.SetPoints[I].Visible := IWCheckBox3.Checked;
  end;

  TIWHTML5Gauge3.AsyncUpdateAllValues;
end;

procedure TIWForm4.IWEdit2AsyncKeyUp(Sender: TObject; EventParams: TStringList);
begin
  TIWHTML5Gauge1.DialText := IWEdit2.Text;
  TIWHTML5Gauge1.AsyncUpdateAllValues;
end;

procedure TIWForm4.IWTimer1AsyncTimer(Sender: TObject;
  EventParams: TStringList);
begin
  TIWHTML5Gauge1.Value := StrToFloat(GetRandomValue);
  TIWHTML5Gauge1.AsyncUpdateAllValues;

  TIWHTML5Gauge2.Value := TIWHTML5Gauge1.Value;
  TIWHTML5Gauge2.AsyncUpdateAllValues;

  TIWHTML5Gauge3.Value := TIWHTML5Gauge1.Value;
  TIWHTML5Gauge3.AsyncUpdateAllValues;
end;

procedure TIWForm4.TIWHTML5Gauge1AsyncGaugeClick(Sender: TObject;
  EventParams: TStringList; Value: Double);
begin
  TIWHTML5Gauge1.Value := Value;
  TIWHTML5Gauge1.AsyncUpdateAllValues;
end;

procedure TIWForm4.TIWHTML5Gauge2AsyncGaugeClick(Sender: TObject;
  EventParams: TStringList; Value: Double);
begin
  TIWHTML5Gauge2.Value := Value;
  TIWHTML5Gauge2.AsyncUpdateAllValues;
end;

procedure TIWForm4.TIWHTML5Gauge3AsyncGaugeClick(Sender: TObject;
  EventParams: TStringList; Value: Double);
begin
  TIWHTML5Gauge3.Value := Value;
  TIWHTML5Gauge3.AsyncUpdateAllValues;
end;

initialization
  TIWForm4.SetAsMainForm;

end.
